{*****************************************************************************}
{*                                                                           *}
{*                32-    .              *}
{*      (c) 1989, 1990 Software Research & Development Laboratory, Sofia.    *}
{*                                                                           *}
{*           ''   UniPascal  *}
{*     Turbo Pascal.      ,        *}
{*    ,   .     -  *}
{*       ,        *}
{*      Turbo Pascal,   UniPascal,   *}
{*         .                        *}
{*                                                                           *}
{*****************************************************************************}

program CS32(output);                                                  {$I-,R-}
  const BuffLen = 1024;                                             { 1 Kbyte }
  (*){*)
  type Cardinal = word;
       LongWord = LongInt;
  {*}
  var ChkSum:  LongInt;
      Nreaded: Cardinal;
      f:       file;
      buffer:  packed array [0..BuffLen-1] of byte;
      fname:   string;

{$ifNdef UniPas}

  function HiWord(L: longword): word;
  begin
    HiWord:= (L div (256*256)) and $ffff;
  end; { HiWord }

  function LoWord(L: longword): word;
  begin
    LoWord:= L and $ffff;
  end; { LoWord }

  procedure WriteLongHex(l: LongInt);
    const Hexs: packed array [0..15] of char = '0123456789abcdef';
  begin
    write(Hexs[Hi(HiWord(l)) div 16], Hexs[Hi(HiWord(l)) mod 16],
          Hexs[Lo(HiWord(l)) div 16], Hexs[Lo(HiWord(l)) mod 16],
          Hexs[Hi(LoWord(l)) div 16], Hexs[Hi(LoWord(l)) mod 16],
          Hexs[Lo(LoWord(l)) div 16], Hexs[Lo(LoWord(l)) mod 16]);
  end; { WriteLongHex }

  procedure ParamStr(No: integer; var s: string);
  begin
    s:= System.ParamStr(No);
  end; { ParamStr }

{$endif}

begin { cs32 }
  writeln('32-bit check sum. (c) 1989, 1990 Software R&D Laboratory, Sofia.'
                                                 (*){*)+ ' IBM PC/XT/AT'{*});
  if ParamCount <> 1 then begin
    writeln('usage: cs32 <filename>'); halt
  end { if };

  ParamStr(1, fname);

  (*) reset(f, fname); {*) FileMode:= 0; assign(f, fname); reset(f, 1); {*}

  if IOresult <> 0 then begin
    writeln('Can''t open ', fname); halt;
  end { if };

  write('A 32 bit check sum of file ', fname, ' is: ');

  (*) if MsgLimit - length(fname) in [32..40] then writeln(message); (*)

  ChkSum:= 0;
  while not EOF(f) do begin
    BlockRead(f, buffer, BuffLen, Nreaded);
    if IOresult <> 0 then begin
      writeln('*** Error reading file ***'); halt;
    end { if };

    while 0 < Nreaded do begin
      dec(Nreaded); inc(ChkSum, buffer[Nreaded]);
    end { while 0 < Nreaded };

    (*) write(message, LongWord(ChkSum), #8#8#8#8#8#8#8#8);
    {*) WriteLongHex(ChkSum); write(#8#8#8#8#8#8#8#8)   {*}
  end { while not EOF(f) };

  (*) writeln(LongWord(ChkSum)); {*) WriteLongHex(ChkSum); writeln; {*}
end { cs32 }.